Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
PGCullTraverser Class Reference

This is a specialization of CullTraverser for use within the pgui system. More...

`#include "pgCullTraverser.h"`

Inheritance diagram for PGCullTraverser:

## Public Member Functions
| PGCullTraverser (PGTop *top, CullTraverser *trav)
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
Public Member Functions inherited from CullTraverser
| CullTraverser (const CullTraverser &copy)
void | draw_bounding_volume (const BoundingVolume *vol, const TransformState *internal_transform) const
| Draws an appropriate visualization of the indicated bounding volume.
virtual void | end_traverse ()
| Should be called when the traverser has finished traversing its scene, this gives it a chance to do any necessary finalization.
const DrawMask & | get_camera_mask () const
| Returns the visibility mask from the camera viewing the scene.
const TransformState * | get_camera_transform () const
| Returns the position of the camera relative to the starting node.
CullHandler * | get_cull_handler () const
| Returns the object that will receive the culled Geoms.
Thread * | get_current_thread () const
| Returns the currently-executing thread object, as passed to the CullTraverser constructor.
bool | get_depth_offset_decals () const
| Returns true, as depth offsets are the only way that we implement decals nowadays.
bool | get_effective_incomplete_render () const
| Returns true if the cull traversal is effectively in incomplete_render state, considering both the GSG's incomplete_render and the current DisplayRegion's incomplete_render flags.
GraphicsStateGuardianBase * | get_gsg () const
| Returns the GraphicsStateGuardian in effect.
const RenderState * | get_initial_state () const
| Returns the initial RenderState at the top of the scene graph we are traversing, or the empty state if the initial state was never set.
PortalClipper * | get_portal_clipper () const
| Returns the _portal_clipper pointer.
SceneSetup * | get_scene () const
| Returns the SceneSetup object.
const std::string & | get_tag_state_key () const
| Returns the tag state key that has been specified for the scene's camera, if any.
GeometricBoundingVolume * | get_view_frustum () const
| Returns the bounding volume that corresponds to the view frustum, or NULL if the view frustum is not in use or has not been set.
const TransformState * | get_world_transform () const
| Returns the position of the starting node relative to the camera.
bool | has_tag_state_key () const
| Returns true if a nonempty tag state key has been specified for the scene's camera, false otherwise.
void | set_camera_mask (const DrawMask &camera_mask)
| Changes the visibility mask for the camera viewing the scene.
void | set_cull_handler (CullHandler *cull_handler)
| Specifies the object that will receive the culled Geoms.
void | set_portal_clipper (PortalClipper *portal_clipper)
| Specifies _portal_clipper object pointer that subsequent traverse() or traverse_below may use.
virtual void | set_scene (SceneSetup *scene_setup, GraphicsStateGuardianBase *gsg, bool dr_incomplete_render)
| Sets the SceneSetup object that indicates the initial camera position, etc.
void | set_view_frustum (GeometricBoundingVolume *view_frustum)
| Specifies the bounding volume that corresponds to the view frustum.
void | traverse (const NodePath &root)
| Begins the traversal from the indicated node.
void | traverse (CullTraverserData &data)
| Traverses from the next node with the given data, which has been constructed with the node but has not yet been converted into the node's space.
virtual void | traverse_below (CullTraverserData &data)
| Traverses all the children of the indicated node, with the given data, which has been converted into the node's space.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CullTraverser
static void | flush_level ()
| Flushes the PStatCollectors used during traversal.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
int | _sort_index
PGTop * | _top
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Attributes inherited from CullTraverser
static PStatCollector | _geom_nodes_pcollector
static PStatCollector | _geoms_occluded_pcollector
static PStatCollector | _geoms_pcollector
static PStatCollector | _nodes_pcollector

## Detailed Description

This is a specialization of CullTraverser for use within the pgui system.

It is substituted in for the normal CullTraverser by the PGTop node. Its purpose is to carry additional data through the traversal so that PGItems can know how to register their regions with the current MouseWatcherGroup.

Definition at line 28 of file pgCullTraverser.h.

## Constructor & Destructor Documentation

## ◆ PGCullTraverser()

PGCullTraverser::PGCullTraverser | ( | PGTop * | top,
|  | CullTraverser * | trav )
| inline

Definition at line 17 of file pgCullTraverser.I.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle PGCullTraverser::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from CullTraverser.

Definition at line 47 of file pgCullTraverser.h.

## ◆ get_class_type()

static TypeHandle PGCullTraverser::get_class_type | ( |  | ) |
| inline static

Definition at line 36 of file pgCullTraverser.h.

## ◆ get_type()

virtual TypeHandle PGCullTraverser::get_type | ( |  | ) | const
| inline virtual

Reimplemented from CullTraverser.

Definition at line 44 of file pgCullTraverser.h.

## ◆ init_type()

static void PGCullTraverser::init_type | ( |  | ) |
| inline static

Definition at line 39 of file pgCullTraverser.h.

## Member Data Documentation

## ◆ _sort_index

int PGCullTraverser::_sort_index

Definition at line 33 of file pgCullTraverser.h.

## ◆ _top

PGTop* PGCullTraverser::_top

Definition at line 32 of file pgCullTraverser.h.

The documentation for this class was generated from the following files:

- panda/src/pgui/pgCullTraverser.h
- panda/src/pgui/pgCullTraverser.cxx
- panda/src/pgui/pgCullTraverser.I